// file: Exchange.m
// the Swarm room
// variables and methods for cell class

#import "Exchange.h"


@implementation Exchange

-createEnd {
  traderSet = [Set create: [self getZone]];
  balance = 0;
  return self;
}

-setTag: (int) t {
  tag = t;
  return self;
}

-(int) getTag {
  return (tag);
}

-setExcess: (int) x {
  excess = x;
  return self;
}

-(int) getExcess {
  return (excess);
}

-setBalance: (int) x {
  balance = x;
  return self;
}

-(int) getBalance {
  return (balance);
}

-addTrader: (id) a {
  trader * b;
  b = (trader *) malloc(sizeof(trader));
  b->who = a;
  b->status = 0;
  [traderSet add: (id) b];
  return self;
}

-setStatusFor: (id) a To: (int) x {
  trader * b;
  id index;
  index = [traderSet begin: [self getZone]];
  while ( (b = (trader *) [index next]) ){
    if (b->who == a){
      b->status = x;
      balance += x;
      break;
    }
  }
  return (self);
}

-changeStatusFor: (id) a By: (int) dx {
  trader * b;
  id index;
  index = [traderSet begin: [self getZone]];
  while ( (b = (trader *) [index next]) ){
    if (b->who == a){
      b->status += dx;
      balance += dx;
      break;
    }
  }
  return (self);
}

-removeTrader: (id) a {
  trader * b;
  id index;
  index = [traderSet begin: [self getZone]];
  while ( (b = (trader *) [index next]) ){
    //    printf("REMOVE: %d looking at %d\n",tag,[b->who getTag]);
    if (b->who == a){
      balance -= b->status;
      [index remove];
      free(b);
      break;
    }
  }
  return (self);
}

-printStatus {
  trader * b;
  id index;
  index = [traderSet begin: [self getZone]];
  while ( (b = (trader *) [index next]) ){
    printf("agent %d connected to %d balance %d\n",tag,[b->who getTag],b->status);
  }
  return (self);
}

@end
